package tome_game

import (
	"log"

	. "git.saintnet.tech/tomecraft/tome_lib"
	"github.com/google/uuid"
)

func NewCard(v, o, p int, id uuid.UUID) *Card {
	if o != ScourgeID && o != SentinalID {
		log.Println("Need valid owner for card")
		return nil
	}
	if id == uuid.Nil {
		id = uuid.New()
	}
	return &Card{
		Type:      CardType(v),
		BasePower: OraclePower(CardType(v), nil),
		Power:     OraclePower(CardType(v), nil),
		Id:        id,
		Sick:      false,
		Counters:  0,
		Owner:     o,
		Position:  p,
		Spell:     OracleSpell(CardType(v), nil),
		Token:     OracleToken(CardType(v), nil),
		Effects:   []*Effect{},
	}
}
